#!/bin/bash
# Config file import
DIR=$(dirname `realpath $0`)
source $DIR/imcesnet.conf
### Automatic mount of the external drive etc
diskDev=$(readlink /dev/disk/by-uuid/$DISK_UUID  -f)
echo $diskDev
if [ $(mount|grep $diskDev|wc -l) == 1 ]; then
        log "Disk je již připojen, přepojuju ... (netřeba se znepokojovat) ..."
	pumount $diskDev
fi
pmount $diskDev rbd
# automount sshfs
if [ -d $SSH_MOUNT_PATH ]; then
	log "Adresář pro připojení vzdáleného disku existuje (tak to má být)"
else
	log "Vytvářím adresář pro připojení vzdáleného disku"
	mkdir $SSH_MOUNT_PATH 
fi
if [ "$(mount|grep  $SSH_MOUNT_PATH)" == "" ]; then
	log "Připojuju vzdálený disk"
	sshfs $SSH_SERVER:$SSH_REMOTE_PATH $SSH_MOUNT_PATH
else
	log "Vzdálený disk je již připojen"
fi
# cd ..
cd /media/rbd
DISK_PATH=$PWD
# takže jsme na disku a jedeme !
dir_listing=$(ls -lt --time-style="+%Y"|egrep -v "done|RECYCLE"|grep "^d"|awk '{s="";for(i=7;i<=NF;i++){s=s"\\ "$i;};print s}'|sed -e s/"^\\\\ "//g)
log "Nyní potřebuji znát identifikační údaje vyšetřených subjektů"
# necháme si zadat informace o všech zpracovávaných adresářích, aby laborant už nemusel nic řešit
declare -a DIRECTORIES
declare -a ID
declare -a ORDER
i=0
for f in $dir_listing; do
        i=$(($i+1))
        echo "Adresář s pacientem $f:"
        DIRECTORIES[$i]=$f
        read -p "Zadej ID (RBD a číslo dohromady):" ID[$i]
        read -p "Zadej pořadí vyšetření (po kolikáté ho vyšetřujeme):" ORDER[$i]
done
echo "************************"
log "Zadávání dokončeno."
echo "Nyní, prosím, zkontroluj ještě jednou zadané údaje:"
echo "#	Adresář				RBDID/pořadí"
echo "====================================================="
for i in "${!DIRECTORIES[@]}"; do
        echo "$i.	${DIRECTORIES[$i]}		${ID[$i]}/${ORDER[$i]}"
done
read -p "Pokud to není správně, stiskni, prosím Ctrl+C a spusť program ještě jednou.
Pokud je všechno v pořádku, stikni ENTER."
echo "***********************************************************"
log "Děkuji za spolupráci. Nyní budu chvíli samostatně pracovat."
echo "***********************************************************"|awk -v num=$i -v doba=33 '{print "Zpracováváme "num" subjektů. Předpokládám, že to bude trvat "(doba*num)" minut (t.j. "int((doba*num)/60)":"((doba*num)%60)" )." ;print $0}'

for index in "${!DIRECTORIES[@]}"; do #main loop
	cd $DISK_PATH/${DIRECTORIES[$index]}
	log "Zpracovávám ${DIRECTORIES[$index]}!"
	cd $(ls -t|head -n1)
	REDCAP_ID=${ID[$index]}
	EX_NUM=${ORDER[$index]}
	DATADIR=`realpath $PWD`

	#Adresar nesmi pro jistotu existovat, abych ho pak mohl smazat. Jinak bych mohl smazat neco co nechci
	TMPDIR=$WORKING_DIR/$REDCAP_ID
### Tohle bylo v defaulu, ale my budeme rovnou posílat přes scp ;-)
###	TARDIR=$TMPDIR/TAR
	ANOMDIR=$TMPDIR/ANOMDIR
	if [ -d "$TMPDIR" ]; then
	        log "Adresář $TMPDIR již existuje. Buď ho smaž, nebo zavolej administratora. Program je ukončen." 
	        exit 1
	fi
	mkdir -p $TMPDIR
	mkdir $ANOMDIR
	TARDIR=$SSH_MOUNT_PATH/$REDCAP_ID/$EX_NUM
	log "Vytvářím cílový adresář na vzdáleném serveru"
	mkdir -p $TARDIR 2>>$LOG_FILE
	#anonymization
	log "Anonymizuji ..."
	gdcmanon --certificate $ANOM_CERT_FILE -e -r $DATADIR $ANOMDIR
	log "Anonymizace subjektu $REDCAP_ID/$EX_NUM dokončena"
	#Tar files
	for D in $ANOMDIR/*/; do
		lognn "Odesílám $D "
		cd $D
		rename s/"^(.*)\.MR\."/"${REDCAP_ID}.$EX_NUM."/g *
		cd ..
		echo -n "."
		dbase=$(basename $D)
		echo -n "."
		tar cvf "$TARDIR/$dbase.tar" -C $D . >/dev/null 2>>$LOG_FILE
		echo " OK"
	done

	# Remove files
	log "Odesílání dokončeno. Odstraňuji dočasné soubory ..."
	rm -rf $TMPDIR 2>>$LOG_FILE
	cd $DISK_PATH
	mv ${DIRECTORIES[$index]} ${DIRECTORIES[$index]}.done
done

log "Odpojuji disky"
log "lokální ..."
pumount rbd 2>>$LOG_FILE
log "vzdálený ..."
fusermount -u $SSH_MOUNT_PATH 2>>$LOG_FILE
log "HOTOVO. Hezký zbytek dne !"

